# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _jarsign_opts --nocopy --skip=%{basedir} --skip=%{bindir} --skip=%{_javadir} 

%define section free

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without zips
%bcond_with ws
%bcond_without repolib

%define with_signing 0
%define patchnumber 01
%define patchlevel -patch-%{patchnumber}
%define release_patchlevel _patch_%{patchnumber}

%define repodir %{_javadir}/repository.jboss.com/apache-tomcat/%{version}%{patchlevel}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define jspspec 2.2
%define major_version 7
%define minor_version 0
%define micro_version 30
%define packdname apache-tomcat-%{version}-src
%define servletspec 3.0
%define elspec 1.0
%define tcuid 91

# FHS 2.3 compliant tree structure - http://www.pathname.com/fhs/2.3/
%define basedir %{_var}/lib/%{name}
%define appdir %{basedir}/webapps
%define homedir %{_datadir}/%{name}
%define bindir %{homedir}/bin
%define confdir %{_sysconfdir}/%{name}
%define libdir %{_javadir}/%{name}
%define logdir %{_var}/log/%{name}
%define cachedir %{_var}/cache/%{name}
%define tempdir %{cachedir}/temp
%define workdir %{cachedir}/work
%define _initrddir %{_sysconfdir}/init.d
%define javasigneddir %{_datadir}/java-signed

Name: tomcat7
Epoch: 0
Version: %{major_version}.%{minor_version}.%{micro_version}
Release: 2%{release_patchlevel}%{?dist}
Summary: Apache Servlet/JSP Engine, RI for Servlet %{servletspec}/JSP %{jspspec} API
Group: Networking/Daemons
License: ASL 2.0
URL: http://tomcat.apache.org/
#http://apache.mirror.rafal.ca/tomcat/tomcat-6/v6.0.32/src/apache-tomcat-6.0.32-src.tar.gz
Source0: http://www.apache.org/dist/tomcat/tomcat-7/v%{version}/src/%{packdname}.tar.gz
Source1: %{name}-%{major_version}.%{minor_version}.conf
Source2: %{name}-%{major_version}.%{minor_version}.init
Source3: %{name}-%{major_version}.%{minor_version}.sysconfig
Source4: %{name}-%{major_version}.%{minor_version}.wrapper
Source5: %{name}-%{major_version}.%{minor_version}.logrotate
Source6: %{name}-%{major_version}.%{minor_version}-digest.script
Source7: %{name}-%{major_version}.%{minor_version}-tool-wrapper.script
#Source8: tomcat6-6.0.24-jsvc.tar.gz
Source9: %{name}-%{major_version}.%{minor_version}-log4j.properties
Source10: %{name}-component-info.xml
# for SELinux
Source11: %{name}-selinux.te
Source12: %{name}-selinux.if
Source13: %{name}-selinux.fc
#Source11: %{name}-7.0.policy
#Source12: %{name}-7.0.JBossPublicKey.RSA
#Source99: sign-unsigned-jars

Patch0: %{name}-%{major_version}.%{minor_version}.25-tomcat-users-webapp.patch
Patch1: %{name}-%{major_version}.%{minor_version}.25-build.patch
# Remove clustering from Tomcat6 in EWS
Patch2: %{name}-7.0.25-noclustering.patch
# Do not build windows zip
Patch3: tomcat7-7.0.27-nowinzips.patch
Patch4: tomcat7-7.0.25-jbpapp-6122-jon.patch
Patch5: tomcat7-7.0.25-jbapp-3749.patch
Patch6: tomcat7-7.0.27-build_extras.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: noarch
BuildRequires: zip
BuildRequires: ant >= 0:1.7.1
BuildRequires: ant-trax
BuildRequires: xalan-j2 >= 0:2.7.1
# Use ecj3 instead of ecj
# Tomcat7 requires ecj 3.7.1
BuildRequires: ecj3 >= 0:3.7.2
BuildRequires: findutils
BuildRequires: apache-commons-collections-tomcat-eap6
BuildRequires: apache-commons-daemon-eap6
BuildRequires: apache-commons-logging-tomcat-eap6
BuildRequires: apache-commons-dbcp-tomcat-eap6
BuildRequires: apache-commons-pool-tomcat-eap6
%if %with ws
BuildRequires: axis >= 0:1.1
BuildRequires: wsdl4j >= 0:1.6.1
%endif
BuildRequires: java-devel >= 0:1.5.0
BuildRequires: jpackage-utils >= 0:1.7.0
BuildRequires: junit
BuildRequires: log4j >= 0:1.2.14

#for uploading to r.j.o/maven2-brew
BuildRequires:  maven-source-plugin
BuildRequires:  maven-deploy-plugin

BuildRequires: jboss-parent

# For SELinux
%if "%{?rhel}" == "6"
BuildRequires: selinux-policy
%else
BuildRequires: selinux-policy-devel
%endif

Requires(pre): shadow-utils
Requires(pre): shadow-utils
Requires: apache-commons-daemon-eap6 
Requires: apache-commons-logging-eap6 >= 0:1.1.1
Requires: java >= 0:1.6.0
Requires: procps
Requires: %{name}-lib = %{epoch}:%{version}-%{release}
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(post): redhat-lsb
Requires(preun): redhat-lsb

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License version 2.0. Tomcat is intended
to be a collaboration of the best-of-breed developers from around the world.

%package admin-webapps
Group: System Environment/Applications
Summary: The host-manager and manager web applications for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description admin-webapps
The host-manager and manager web applications for Apache Tomcat.

%if %with ws
%package ws
Group: Internet/WWW/Dynamic Content
Summary: Web Services (JSR 109) support for Apache Tomcat
Requires: axis >= 0:1.1
Requires: wsdl4j >= 0:1.6.1

%description ws
Tomcat provides factories for JSR 109 which may be used to resolve web services
references.
%endif

%package docs-webapp
Group: System Environment/Applications
Summary: The docs web application for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description docs-webapp
The docs web application for Apache Tomcat.

%package el-%{elspec}-api
Summary: Expression Language v1.0 API
Group: Development/Libraries/Java
Provides: el_1_0_api = %{epoch}:%{version}-%{release}
Provides: el_api = 0:1.0
Requires(preun):  %{_sbindir}/update-alternatives
Requires(post):  %{_sbindir}/update-alternatives

%description el-%{elspec}-api
Expression Language 1.0.

%package javadoc
Group: Documentation
Summary: Javadoc generated documentation for Apache Tomcat
Requires(pre): coreutils

%description javadoc
Javadoc generated documentation for Apache Tomcat.

%package jsp-%{jspspec}-api
Group: Internet/WWW/Dynamic Content
Summary: Apache Tomcat JSP API implementation classes
Provides: jsp = %{jspspec}
Provides: jsp21
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%description jsp-%{jspspec}-api
Apache Tomcat JSP API implementation classes.

%package log4j
Group: Internet/WWW/Dynamic Content
Summary: Log4J support for Apache Tomcat
# The jar is copied over instead of linking because it is in base
#Requires: log4j
Requires: apache-commons-logging-eap6

%description log4j
Log4J support for Apache Tomcat.

%package lib
Group: Development/Compilers
Summary: Libraries needed to run the Tomcat Web container
Requires: %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
# This is copied to jasper-jdt.jar. Linking is broken
Requires: ecj3 >= 1:3.7.2
#Requires: apache-commons-collections-tomcat-eap6
#Requires: apache-commons-dbcp-tomcat-eap6
#Requires: apache-commons-pool-tomcat-eap6
Requires(preun): coreutils

%description lib
Libraries needed to run the Tomcat Web container.

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content
Summary: Apache Tomcat Servlet API implementation classes
Provides: servlet = %{servletspec}
Provides: servlet6
#Provides: servlet25
Provides: servlet30
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%description servlet-%{servletspec}-api
Apache Tomcat Servlet API implementation classes.

%package webapps
Group: System Environment/Applications
Summary: The ROOT and examples web applications for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description webapps
The ROOT and examples web applications for Apache Tomcat.

%if %with zips
%package zip
Summary:     Container for the zipped distribution of tomcat7
Group:       Development

%description zip
Container for the zipped distribution of tomcat7

%package src-zip
Summary:     Container for the sources
Group:       Development

%description src-zip
Container for the sources
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
echo Prep Phase
%setup -q -c -T -a 0
%{_bindir}/find . -type f -name "*.[jw]ar" -o -type f -name "*.bat" -o -type f -name "*.pdf" | %{_bindir}/xargs -t %{__rm}
pushd %{packdname}
#JBPAPP-3653
# Does not exist in tomcat7
#sed -i -e '/<target name="package-zip">/,/<\/target>/s/eol="crlf"/eol="lf"/' dist.xml

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0

%{__ln_s} $(build-classpath ecj3) jasper-jdt.jar
popd

%{__cat} > README.CVE-2007-1355 << EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML><HEAD><TITLE>Examples Removed</TITLE>
<META http-equiv=Content-Type content="text/html">
</HEAD>
<BODY>
<P>
<H>Note: The following files have been removed due to CVE-2007-1355:

</P>
<P>
%{appdir}/examples/servlets/*
</P>
<P>
%{appdir}/examples/jsp/*
</P>
<P>
%{appdir}/docs/appdev/sample/*
</P>
</H>
</BODY></HTML>
EOF

pushd %{packdname}
%{__mkdir_p} output/extras
#%{__ln_s} $(build-classpath commons-logging-adapters) output/extras/tomcat-juli-adapters.jar
%if %with ws
%{__mkdir_p} output/extras/webservices
%{__ln_s} $(build-classpath axis/jaxrpc) output/extras/webservices/jaxrpc.jar
%{__ln_s} $(build-classpath wsdl4j/wsdl4j16) output/extras/webservices/wsdl4j.jar
%endif
popd

%build
echo Build Phase
export CLASSPATH=%(build-classpath xalan-j2)
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/trax` xalan-j2-serializer"
echo DEBUG
pushd %{packdname}
	touch HACK
	%{__cp} $(build-classpath commons-dbcp-eap6) commons-dbcp-eap6.jar
    # We don't care about the tarballs
    # Who needs a build.properties file anyway
    %{ant} -Dbase.path="." \
        -Dbuild.compiler="modern" \
        -Dcommons-daemon.jsvc.tar.gz="HACK" \
        -Djasper-jdt.jar="jasper-jdt.jar" \
        -Djdt.jar="jasper-jdt.jar" \
        -Dtomcat-dbcp.jar="commons-dbcp-eap6.jar" \
        -Dtomcat-native.tar.gz="" \
        -Dversion="%{version}" \
		  -Dversion.patch="Red_Hat_EWS" \
        -Dversion.build="%{micro_version}-%{release}" \
        -Dcommons-collections.jar="$(build-classpath commons-collections-eap6)" \
        -Dcommons-daemon.jar="$(build-classpath commons-daemon-eap6)" \
		  -Dno.build.dbcp=true \
		  deploy dist-prepare dist-source javadoc \
		  package-src-zip

# Needed later. build.xml no longer can do it without complications
	mkdir -p tmp/apache-tomcat-%{version}
	pushd tmp
	pushd apache-tomcat-%{version}
	  %{__cp} -r ../../output/build/* .
	popd
     zip -r -q ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip \
	    apache-tomcat-%{version}/* -x bin/service.bat bin/i64 bin/*.exe bin/*.dll
	popd
	rm -rf tmp

    # extras generation
%if %with ws
    %{ant} -Dbase.path="." \
        -Dbuild.compiler="modern" \
        -Dcommons-daemon.jsvc.tar.gz="HACK" \
        -Djasper-jdt.jar="jasper-jdt.jar" \
        -Djdt.jar="jasper-jdt.jar" \
        -Dtomcat-dbcp.jar="$(build-classpath commons-dbcp-eap6)" \
        -Dtomcat-native.tar.gz="" \
        -Dversion="%{version}" \
		  -Dversion.patch="Red Hat EWS" \
        -Dversion.build="%{micro_version}-%{release}" \
        -Dcommons-collections.jar="$(build-classpath commons-collections-eap6)" \
        -Dcommons-daemon.jar="$(build-classpath commons-daemon-eap6)" \
		   extras
%else
    %{ant} -Dbase.path="." \
        -Dbuild.compiler="modern" \
        -Dcommons-daemon.jsvc.tar.gz=HACK \
        -Djasper-jdt.jar="jasper-jdt.jar" \
        -Djdt.jar="jasper-jdt.jar" \
        -Dtomcat-dbcp.jar="commons-dbcp-eap6.jar" \
        -Dtomcat-native.tar.gz="" \
        -Dversion="%{version}" \
		  -Dversion.patch="Red Hat EWS" \
        -Dversion.build="%{micro_version}-%{version}" \
        -Dcommons-collections.jar="$(build-classpath commons-collections-eap6)" \
        -Dcommons-daemon.jar="$(build-classpath commons-daemon-eap6)" \
		  extras-commons-logging
%endif
    #%{__mkdir_p} tmp
    #pushd tmp
    #%{jar} xf ../output/extras/tomcat-juli.jar
    #%{jar} xf $(build-classpath commons-logging-adapters)
    #%{jar} cf ../output/extras/tomcat-juli.jar *
    #popd
    #rm -r tmp

#    # dist generation
#    %{ant} -Dbase.path="." \
#        -Dbuild.compiler="modern" \
#        -Dcommons-daemon.jsvc.tar.gz=../jsvc.tar.gz \
#        -Djasper-jdt.jar="jasper-jdt.jar" \
#        -Djdt.jar="jasper-jdt.jar" \
#        -Dtomcat-dbcp.jar="tomcat-dbcp.jar" \
#        -Dtomcat-native.tar.gz="" \
#        -Dversion="%{version}" \
#		  -Dversion.patch="Red Hat EWS" \
#        -Dversion.build="%{micro_version}-%{release}" \
#        -Dcommons-collections.jar="$(build-classpath commons-collections)" \
#        -Dcommons-daemon.jar="$(build-classpath commons-daemon)" \
#        -Dskip.installer=true -f dist.xml

    # remove some jars that we'll replace with symlinks later
    # %{__rm} output/build/bin/commons-daemon.jar
    %{__rm} output/build/lib/jasper-jdt.jar
#    %{__rm} output/build/lib/tomcat-jdbc.jar
	 %{__rm} output/build/lib/catalina-ha.jar
	 %{__rm} HACK

	# ZIPS
    # make modification in the zip
    %if %with zips
	 echo Zips
    %{__mkdir_p} tmp
    pushd tmp
    # add jsvc.tar.gz to src.zip
    unzip -q ../output/release/v%{version}/src/apache-tomcat-%{version}-src.zip

# rename commons-daemon-eap6 to commons-daemon. it causes problems for downstream
# builds
    cp $(build-classpath commons-daemon-eap6) apache-tomcat-%{version}-src/commons-daemon.jar
    cp $(build-classpath commons-collections-eap6) apache-tomcat-%{version}-src/commons-collections-eap6.jar
    cp $(build-classpath commons-pool-eap6) apache-tomcat-%{version}-src/commons-pool-eap6.jar
    cp $(build-classpath commons-dbcp-eap6) apache-tomcat-%{version}-src/commons-dbcp-eap6.jar
    cp $(build-classpath commons-logging-api) apache-tomcat-%{version}-src/commons-logging-api.jar
    cp $(build-classpath commons-logging-adapters) apache-tomcat-%{version}-src/commons-logging-adapters.jar
	 cp %{SOURCE11} apache-tomcat-%{version}-src/%{name}.te
	 cp %{SOURCE12} apache-tomcat-%{version}-src/%{name}.if
	 cp %{SOURCE13} apache-tomcat-%{version}-src/%{name}.fc
    rm ../output/release/v%{version}/src/apache-tomcat-%{version}-src.zip
#JBPAPP-3654 Last chance to get rid of any junk
    find apache-tomcat-%{version}-src -name "*.orig" | xargs -t %{__rm} -f
    zip -q -r ../output/release/v%{version}/src/apache-tomcat-%{version}-src.zip \
       apache-tomcat-%{version}-src
    rm -fr *

    # binary zip
    cat > README.CVE-2007-1355.tomcat7 << EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML><HEAD><TITLE>Examples Removed</TITLE>
<META http-equiv=Content-Type content="text/html">
</HEAD>
<BODY>
<P>
<H>Note: The following files have been removed due to CVE-2007-1355:

</P>
<P>
tomcat7/webapps/examples/servlets/*
</P>
<P>
tomcat7/webapps/examples/jsp/*
</P>
<P>
tomcat7/webapps/docs/appdev/sample/*
</P>
</H>
</BODY></HTML>
EOF

    unzip -q ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip
    #create zip for QE to run examples
    zip -q -r ../output/release/v%{version}/bin/apache-tomcat-%{version}-examples.zip \
         apache-tomcat-%{version}/webapps/examples/servlets/* apache-tomcat-%{version}/webapps/examples/jsp/* \
         apache-tomcat-%{version}/webapps/examples/WEB-INF apache-tomcat-%{version}/webapps/docs/appdev/sample/*
    %{__rm} -r apache-tomcat-%{version}/webapps/examples/servlets/*
    %{__rm} -r apache-tomcat-%{version}/webapps/examples/jsp/*
    %{__rm} -r apache-tomcat-%{version}/webapps/examples/WEB-INF
    %{__rm} -r apache-tomcat-%{version}/webapps/docs/appdev/sample/*
    #JBPAPP-3659
    %{__rm} -r apache-tomcat-%{version}/webapps/docs/tribes
# JBPAPP-9557
	 %{__rm} apache-tomcat-%{version}/lib/catalina-ha.jar
    cp -pr README.CVE-2007-1355.tomcat7 apache-tomcat-%{version}/webapps/examples/servlets/index.html
    cp -pr README.CVE-2007-1355.tomcat7 apache-tomcat-%{version}/webapps/examples/jsp/index.html
    cp -pr README.CVE-2007-1355.tomcat7 apache-tomcat-%{version}/webapps/docs/appdev/sample/index.html
    chmod 755 apache-tomcat-%{version}/bin/*sh
    sed -i -e 's/\"$_RUNJAVA\"/$_RUNJAVA/g' apache-tomcat-%{version}/bin/catalina.sh \
       apache-tomcat-%{version}/bin/tool-wrapper.sh
    %{__mkdir_p} apache-tomcat-%{version}/extras

    # On RHEL-6 the signed JARs are on a different place
#    export JPP_SIGNED=2

	# Replace stock libs with ews libs. Make the rpms and zips symetrical
	echo Zips:Replace stock libs with ews libs 
	 # Populate extras. 
    (cd apache-tomcat-%{version}/extras; ln -sf $(build-classpath log4j) . ;
	 	cp %{SOURCE9} log4j.properties )

	# Copy the EWS2 libs
	 %{__cp} -p $(build-classpath commons-daemon-eap6) apache-tomcat-%{version}/bin/commons-daemon.jar
	 %{__cp} -p $(build-classpath commons-collections-eap6) apache-tomcat-%{version}/lib/commons-collections-eap6.jar
	 %{__cp} -p $(build-classpath commons-dbcp-eap6) apache-tomcat-%{version}/lib/commons-dbcp-eap6.jar
	 %{__cp} -p $(build-classpath commons-pool-eap6) apache-tomcat-%{version}/lib/commons-pool-eap6.jar
	 %{__cp} -p $(build-classpath commons-logging-adapters) apache-tomcat-%{version}/lib/commons-logging-adapters.jar
	 %{__cp} -p $(build-classpath commons-logging-api) apache-tomcat-%{version}/lib/commons-logging-api.jar
	# Replace the existing jdt jar with ecj3 as done for the rpms
	 %{__cp} -p $(build-classpath ecj3) apache-tomcat-%{version}/lib/jaspter-jdt.jar

    %{__rm} ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip

    #Currently turned off
    %if %with_signing
      cp %{SOURCE99} .
      ./sign-unsigned-jars jbosscodesign2009 .
      %{__rm} sign-unsigned-jars
    %endif

#JBPAPP-3654 Last chance to get rid of any junk
	 find apache-tomcat-%{version} -name "*.orig" | xargs -t %{__rm} -f
    zip -q -r ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip apache-tomcat-%{version}/
    %{__rm} -fr apache-tomcat-%{version}/extras
    popd
    %{__rm} -fr tmp
	 echo End Zips
    %endif

%install
echo Install Phase
%{__rm} -rf $RPM_BUILD_ROOT
# build initial path structure
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sbindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_initrddir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{appdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{bindir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/Catalina/localhost
# for SELinux
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/selinux/packages/%{name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{libdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{logdir}
/bin/touch ${RPM_BUILD_ROOT}%{logdir}/catalina.out
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{homedir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{tempdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{workdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/selinux/packages/%{name}

# move things into place
echo Install:Copy things into place

# For SELinux
echo "SELinux Policy Build"
%{__mkdir_p} tmp/selinux
pushd tmp/selinux
%{__cp} -p %{SOURCE11} %{name}.te
%{__cp} -p %{SOURCE12} %{name}.if
%{__cp} -p %{SOURCE13} %{name}.fc
make -f %{_datadir}/selinux/devel/Makefile

%{__install} -p -m 0644 -D tomcat7.pp ${RPM_BUILD_ROOT}%{confdir}/selinux/packages/%{name}/%{name}.pp
%{__install} -p -m 0644 -D tomcat7.te ${RPM_BUILD_ROOT}%{confdir}/selinux/packages/%{name}/%{name}.te
%{__install} -p -m 0644 -D tomcat7.if ${RPM_BUILD_ROOT}%{confdir}/selinux/packages/%{name}/%{name}.if
%{__install} -p -m 0644 -D tomcat7.fc ${RPM_BUILD_ROOT}%{confdir}/selinux/packages/%{name}/%{name}.fc
popd
# clean up
%{__rm} -rf tmp/selinux

pushd %{packdname}/output/build
    %{__cp} -a bin/*.{jar,xml} ${RPM_BUILD_ROOT}%{bindir}
    %{__cp} -a conf/*.{policy,properties,xml} ${RPM_BUILD_ROOT}%{confdir}
    %{__cp} -a lib/*.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a webapps/* ${RPM_BUILD_ROOT}%{appdir}

    %{__rm} -r $RPM_BUILD_ROOT%{appdir}/examples/servlets/*
    %{__rm} -r $RPM_BUILD_ROOT%{appdir}/examples/jsp/*
    %{__rm} -r $RPM_BUILD_ROOT%{appdir}/examples/WEB-INF
    %{__rm} -r $RPM_BUILD_ROOT%{appdir}/docs/appdev/sample/*
    cp -p ../../../README.CVE-2007-1355 $RPM_BUILD_ROOT%{appdir}/examples/servlets/index.html
    cp -p ../../../README.CVE-2007-1355 $RPM_BUILD_ROOT%{appdir}/examples/jsp/index.html
    cp -p ../../../README.CVE-2007-1355 $RPM_BUILD_ROOT%{appdir}/docs/appdev/sample/index.html
popd
# On RHEL-6 the signed JARs are on a different place
#export JPP_SIGNED=2
%if %with ws
# ws
%{__cp} -p %{packdname}/output/extras/catalina-ws.jar ${RPM_BUILD_ROOT}%{libdir}/catalina-ws.jar
%{__ln_s} $(build-classpath axis/jaxrpc) ${RPM_BUILD_ROOT}%{libdir}/jaxrpc.jar
%{__ln_s} $(build-classpath wsdl4j/wsdl4j16) ${RPM_BUILD_ROOT}%{libdir}/wsdl4j.jar
%endif
# juli
#%{__cp} -p %{packdname}/output/extras/tomcat-juli-adapters.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-juli-adapters.jar
#jbpapp-6698
#%{__ln_s} $(build-classpath commons-logging-tomcat-juli) ${RPM_BUILD_ROOT}%{bindir}/commons-logging-tomcat-juli.jar
%{__cp} -p $(build-classpath commons-daemon-eap6) ${RPM_BUILD_ROOT}%{bindir}/commons-daemon.jar

#copy log4j.jar over as it is in base
#%{__ln_s} $(build-classpath log4j) ${RPM_BUILD_ROOT}%{libdir}/log4j.jar
%{__cp} -p $(build-classpath log4j) ${RPM_BUILD_ROOT}%{libdir}/log4j.jar
%{__cp} -p %{SOURCE9} ${RPM_BUILD_ROOT}%{confdir}/log4j.properties
(cd ${RPM_BUILD_ROOT}%{libdir} && %{__ln_s} %{confdir}/log4j.properties log4j.properties)

# javadoc
pushd %{packdname}/output/dist/webapps
    %{__cp} -a docs/api/* ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}
popd
#JBPAPP-3659
%{__rm} -r ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}/org/apache/catalina/tribes
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE1} \
    > ${RPM_BUILD_ROOT}%{confdir}/%{name}.conf
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE3} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 0755 %{SOURCE2} \
    ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
%{__install} -m 0755 %{SOURCE4} \
    ${RPM_BUILD_ROOT}%{_sbindir}/%{name}
%{__ln_s} %{name} ${RPM_BUILD_ROOT}%{_sbindir}/d%{name}
%{__sed} -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g" %{SOURCE5} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE6} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{name}-digest
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE7} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{name}-tool-wrapper
pushd ${RPM_BUILD_ROOT}%{_javadir}
    # create jsp and servlet and el API symlinks
    %{__mv} %{name}/jsp-api.jar %{name}-jsp-%{jspspec}-api-%{version}.jar
    %{__mv} %{name}/servlet-api.jar %{name}-servlet-%{servletspec}-api-%{version}.jar
    %{__mv} %{name}/el-api.jar %{name}-el-%{elspec}-api-%{version}.jar
    /bin/touch el_1_0_api.jar
    /bin/touch el-api.jar
    /bin/touch jsp.jar
    /bin/touch servlet.jar
    %{__ln_s} %{name}-jsp-%{jspspec}-api-%{version}.jar %{name}-jsp-%{jspspec}-api.jar
    %{__ln_s} %{name}-servlet-%{servletspec}-api-%{version}.jar %{name}-servlet-%{servletspec}-api.jar
    %{__ln_s} %{name}-el-%{elspec}-api-%{version}.jar %{name}-el-%{elspec}-api.jar
popd
pushd ${RPM_BUILD_ROOT}%{libdir}
    # fix up jars to include version number
#	%{__rm} tomcat-dbcp.jar
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__mv} ${j}.jar ${j}-%{version}.jar
        %{__ln_s} ${j}-%{version}.jar ${j}.jar
    done
    # symlink JSP and servlet and el API jars
    %{__ln_s} ../%{name}-jsp-%{jspspec}-api-%{version}.jar .
    %{__ln_s} ../%{name}-servlet-%{servletspec}-api-%{version}.jar .
    %{__ln_s} ../%{name}-el-%{elspec}-api-%{version}.jar .

	# copy to avoid broken symlinks.
	# commons-logging-api
	%{__cp} -p $(build-classpath commons-dbcp-eap6) commons-dbcp-eap6.jar
	%{__cp} -p $(build-classpath commons-pool-eap6) commons-pool-eap6.jar
	%{__cp} -p $(build-classpath commons-collections-eap6) commons-collections-eap6.jar
	%{__cp} -p $(build-classpath ecj3) jasper-jdt.jar
# copy log4j.jar over as it is in base
	%{__cp} $(build-classpath commons-logging-api) .
	%{__cp} -p $(build-classpath commons-logging-adapters) .
	%{__cp} -p $(build-classpath log4j) .
popd

pushd ${RPM_BUILD_ROOT}%{bindir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__mv} ${j}.jar ${j}-%{version}.jar
        %{__ln_s} ${j}-%{version}.jar ${j}.jar
    done
popd
# symlink to the FHS locations where we've installed things
pushd ${RPM_BUILD_ROOT}%{homedir}
    %{__ln_s} %{appdir} webapps
    %{__ln_s} %{confdir} conf
    %{__ln_s} %{libdir} lib
    %{__ln_s} %{logdir} logs
    %{__ln_s} %{tempdir} temp
    %{__ln_s} %{workdir} work
popd

# install sample webapp
#%{__mkdir_p} ${RPM_BUILD_ROOT}%{appdir}/sample
#CURDIR="`pwd`"
#pushd ${RPM_BUILD_ROOT}%{appdir}/sample
#%{jar} xf "${CURDIR}/%{packdname}/output/build/webapps/docs/appdev/sample/sample.war"
#popd

%if %with zips
echo Zips
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
# Copy over source zip for the src-zip subpackage
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/src/apache-tomcat-%{version}-src.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat7-%{version}-src.zip
# Copy over zip for the zip subpackage
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/bin/apache-tomcat-%{version}-examples.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat7-%{version}-examples.zip
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/bin/apache-tomcat-%{version}.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat7-%{version}.zip
echo End Zips
%endif

%if %with repolib
   echo RepoLib
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -p -m 0644 %{SOURCE10} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	sed -i 's/@VERSION@/%{version}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
    tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
    sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml

	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE6} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE7} $RPM_BUILD_ROOT%{repodirsrc}
#	install -p -m 0644 %{SOURCE8} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE9} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE11} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE12} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE13} $RPM_BUILD_ROOT%{repodirsrc}


	install -p -m 0644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{PATCH3} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{PATCH4} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{PATCH5} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{PATCH6} $RPM_BUILD_ROOT%{repodirsrc}

#	cp -p $RPM_BUILD_ROOT%{libdir}/catalina-ant.jar $RPM_BUILD_ROOT%{repodirlib}
#	cp -p $RPM_BUILD_ROOT%{libdir}/catalina.jar $RPM_BUILD_ROOT%{repodirlib}
#	cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-el-%{elspec}-api.jar $RPM_BUILD_ROOT%{repodirlib}/el-api.jar
#	cp -p $RPM_BUILD_ROOT%{libdir}/jasper.jar $RPM_BUILD_ROOT%{repodirlib}
#	cp -p $RPM_BUILD_ROOT%{libdir}/jasper-el.jar $RPM_BUILD_ROOT%{repodirlib}
#	cp -p $RPM_BUILD_ROOT%{libdir}/jasper-jdt.jar $RPM_BUILD_ROOT%{repodirlib}
#	cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-jsp-%{jspspec}-api.jar $RPM_BUILD_ROOT%{repodirlib}/jsp-api.jar
#    cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-servlet-%{servletspec}-api.jar $RPM_BUILD_ROOT%{repodirlib}/servlet-api.jar
#    cp -p $RPM_BUILD_ROOT%{libdir}/tomcat-coyote.jar $RPM_BUILD_ROOT%{repodirlib}
#    cp -p $RPM_BUILD_ROOT%{libdir}/tomcat-i18n-es.jar $RPM_BUILD_ROOT%{repodirlib}
#    cp -p $RPM_BUILD_ROOT%{libdir}/tomcat-i18n-fr.jar $RPM_BUILD_ROOT%{repodirlib}
#    cp -p $RPM_BUILD_ROOT%{libdir}/tomcat-i18n-ja.jar $RPM_BUILD_ROOT%{repodirlib}

    sed -i -e 's/@MAVEN.DEPLOY.VERSION@/%{version}/g' apache-tomcat-%{version}-src/res/maven/*.pom
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-catalina -Dfile=apache-tomcat-%{version}-src/output/build/lib/catalina.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-catalina.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-coyote -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-coyote.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-coyote.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-el-api -Dfile=apache-tomcat-%{version}-src/output/build/lib/el-api.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-el-api.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-jasper-el -Dfile=apache-tomcat-%{version}-src/output/build/lib/jasper-el.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-jasper-el.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-jasper -Dfile=apache-tomcat-%{version}-src/output/build/lib/jasper.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-jasper.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-jsp-api -Dfile=apache-tomcat-%{version}-src/output/build/lib/jsp-api.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-jsp-api.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-servlet-api -Dfile=apache-tomcat-%{version}-src/output/build/lib/servlet-api.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-servlet-api.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-juli -Dfile=apache-tomcat-%{version}-src/output/build/bin/tomcat-juli.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-juli.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-annotations-api -Dfile=apache-tomcat-%{version}-src/output/build/lib/annotations-api.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-annotations-api.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-catalina-ant -Dfile=apache-tomcat-%{version}-src/output/build/lib/catalina-ant.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-catalina-ant.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-jdbc -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-jdbc.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-jdbc.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-api -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-api.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-api.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-i18n-fr -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-api.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-i18n-fr.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-i18n-es -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-i18n-es.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-i18n-es.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-i18n-ja -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-i18n-ja.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-i18n-ja.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
    %{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{version} -Dpackaging=jar -DartifactId=tomcat-util -Dfile=apache-tomcat-%{version}-src/output/build/lib/tomcat-util.jar -DpomFile=apache-tomcat-%{version}-src/res/maven/tomcat-util.pom -Durl=file://%{buildroot}/usr/share/java-signed/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
echo End RepoLib
%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# add the tomcat user and group
%{_sbindir}/groupadd -g %{tcuid} -r tomcat 2>/dev/null || :
%{_sbindir}/useradd -c "Apache Tomcat" -u %{tcuid} -g tomcat \
    -s /sbin/nologin -r -d %{homedir} tomcat 2>/dev/null || :

%post
# install but don't activate
/sbin/chkconfig --add %{name}
# For SELinux
if [ $1 -eq 1 ] && [ -x "%{_sbindir}/selinuxenabled" ]; then
	%{_sbindir}/semanage port -a -t %{name}_port_t -p tcp 8080 >/dev/null 2>&1 ||:
	%{_sbindir}/semanage port -a -t %{name}_port_t -p tcp 8005 >/dev/null 2>&1 ||:
	%{_sbindir}/semanage port -a -t %{name}_port_t -p tcp 8009 >/dev/null 2>&1 ||:
	%{_sbindir}/semanage port -a -t %{name}_port_t -p tcp 8443 >/dev/null 2>&1 ||:
	%{_bindir}/semodule -i %{}/selinux/packages/%{name}/%{name}.pp 2>/dev/null ||:
fi

%post el-1.0-api
# On RHEL-6 the signed JARs are on a different place
#export JPP_SIGNED=2

%{_sbindir}/update-alternatives --install %{_javadir}/el-api.jar el_api %{_javadir}/%{name}-el-%{elspec}-api.jar 10000
%{_sbindir}/update-alternatives --install %{_javadir}/el_1_0_api.jar el_1_0_api %{_javadir}/%{name}-el-%{elspec}-api.jar 10000

%preun el-1.0-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove el_api %{_javadir}/%{name}-el-%{elspec}-api.jar
    %{_sbindir}/update-alternatives --remove el_1_0_api %{_javadir}/%{name}-el-%{elspec}-api.jar
fi

%pre javadoc
%{__rm} -rf %{_javadocdir}/%{name}

%post jsp-%{jspspec}-api
# On RHEL-6 the signed JARs are on a different place
#export JPP_SIGNED=2

%{_sbindir}/update-alternatives --install %{_javadir}/jsp.jar jsp \
    %{_javadir}/%{name}-jsp-%{jspspec}-api.jar 20100

%post servlet-%{servletspec}-api
# On RHEL-6 the signed JARs are on a different place
#export JPP_SIGNED=2

%{_sbindir}/update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{name}-servlet-%{servletspec}-api.jar 20500

%preun
if [ "$1" = "0" ]; then
	 %{__rm} -rf %{workdir}/* %{tempdir}/*
    %{_initrddir}/%{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
# For SELinux
	 if [ -x "%{_sbindir}/selinuxenabled" ]; then
		%{_sbindir}/semanage port -d -t %{name}_port_t -p tcp 8080 >/dev/null 2>&1 ||:
		%{_sbindir}/semanage port -d -t %{name}_port_t -p tcp 8005 >/dev/null 2>&1 ||:
		%{_sbindir}/semanage port -d -t %{name}_port_t -p tcp 8009 >/dev/null 2>&1 ||:
		%{_sbindir}/semanage port -d -t %{name}_port_t -p tcp 8443 >/dev/null 2>&1 ||:
		%{_sbindir}/semodule -r %{name} 2>/dev/null ||:
	fi 
fi

%postun jsp-%{jspspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jsp \
        %{_javadir}/%{name}-jsp-%{jspspec}-api.jar
fi

%postun servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove servlet \
        %{_javadir}/%{name}-servlet-%{servletspec}-api.jar
fi

%files
%defattr(0664,root,root,0775)
%doc %{packdname}/{LICENSE,NOTICE,RELEASE-NOTES,*.txt}
%attr(0755,root,root) %{_bindir}/%{name}-digest
%attr(0755,root,root) %{_bindir}/%{name}-tool-wrapper
%attr(0755,root,root) %{_sbindir}/d%{name}
%attr(0755,root,root) %{_sbindir}/%{name}
%attr(0755,root,root) %{_initrddir}/%{name}
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(0775,root,tomcat) %dir %{basedir}
%attr(0775,tomcat,root) %dir %{appdir}
%attr(0775,tomcat,root) %dir %{confdir}
%attr(0775,tomcat,root) %dir %{confdir}/Catalina
%attr(0775,tomcat,root) %dir %{confdir}/Catalina/localhost
# for SELinux
%attr(0664,tomcat,root) %dir %{confdir}/selinux
%attr(0664,tomcat,root) %dir %{confdir}/selinux/packages
%attr(0664,tomcat,root) %dir %{confdir}/selinux/packages/%{name}
%attr(0664,tomcat,root) %config(noreplace) %{confdir}/selinux/packages/%{name}/%{name}.pp
%attr(0664,tomcat,root) %config(noreplace) %{confdir}/selinux/packages/%{name}/%{name}.if
%attr(0664,tomcat,root) %config(noreplace) %{confdir}/selinux/packages/%{name}/%{name}.te
%attr(0664,tomcat,root) %config(noreplace) %{confdir}/selinux/packages/%{name}/%{name}.fc

%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/%{name}.conf
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/catalina.policy
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/catalina.properties
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/logging.properties
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/context.xml
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/server.xml
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/tomcat-users.xml
%attr(0664,tomcat,tomcat) %config(noreplace) %{confdir}/web.xml
%attr(0775,tomcat,root) %dir %{cachedir}
%attr(0775,tomcat,root) %dir %{tempdir}
%attr(0775,tomcat,root) %dir %{workdir}
%attr(0775,tomcat,root) %dir %{logdir}
%attr(0664,tomcat,tomcat) %{logdir}/catalina.out
%attr(0775,root,tomcat) %{homedir}/conf
%dir %{homedir}
%{bindir}/bootstrap-%{version}.jar
%{bindir}/bootstrap.jar
%{bindir}/catalina-tasks.xml
%{bindir}/commons-daemon.jar
%{bindir}/commons-daemon-%{version}.jar
%{bindir}/tomcat-juli-%{version}.jar
%{bindir}/tomcat-juli.jar
%{homedir}/lib
%{homedir}/logs
%{homedir}/temp
%{homedir}/webapps
%{homedir}/work

%files admin-webapps
%defattr(0644,root,root,0755)
%{appdir}/host-manager
%{appdir}/manager

%if %with ws
%files ws
%defattr(0644,root,root,0755)
%{libdir}/catalina-ws-%{version}.jar
%{libdir}/catalina-ws.jar
%{libdir}/jaxrpc-%{version}.jar
%{libdir}/jaxrpc.jar
%{libdir}/wsdl4j-%{version}.jar
%{libdir}/wsdl4j.jar
%endif

%files docs-webapp
%defattr(0644,root,root,0755)
%{appdir}/docs

%files el-%{elspec}-api
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-el-%{elspec}-api-%{version}.jar
%{_javadir}*/%{name}-el-%{elspec}-api.jar
%{_javadir}*/%{name}/%{name}-el-%{elspec}-api-%{version}.jar
%ghost %{_javadir}*/el_1_0_api.jar
%ghost %{_javadir}*/el-api.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files jsp-%{jspspec}-api
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-jsp-%{jspspec}-api-%{version}.jar
%{_javadir}*/%{name}-jsp-%{jspspec}-api.jar
%ghost %{_javadir}*/jsp.jar

%files log4j
%defattr(0644,root,root,0755)
%config(noreplace) %{confdir}/log4j.properties
%{libdir}/log4j.properties
%{libdir}/log4j-%{version}.jar
%{libdir}/log4j.jar

%files lib
%defattr(0644,root,root,0755)
%{libdir}/annotations-api-%{version}.jar
%{libdir}/annotations-api.jar
%{libdir}/catalina-%{version}.jar
%{libdir}/catalina-ant-%{version}.jar
%{libdir}/catalina-ant.jar
%{libdir}/catalina.jar
%{libdir}/commons-collections-eap6.jar
%{libdir}/commons-dbcp-eap6.jar
%{libdir}/commons-dbcp-eap6-%{version}.jar
%{libdir}/commons-pool-eap6.jar
%{libdir}/tomcat-jdbc.jar
%{libdir}/tomcat-jdbc-%{version}.jar
%{libdir}/tomcat-util.jar
%{libdir}/tomcat-util-%{version}.jar
%{libdir}/tomcat-api.jar
%{libdir}/tomcat-api-%{version}.jar
%{libdir}/jasper-jdt.jar
%{libdir}/jasper-%{version}.jar
%{libdir}/jasper-el-%{version}.jar
%{libdir}/jasper-el.jar
%{libdir}/jasper.jar
%{libdir}/tomcat-coyote-%{version}.jar
%{libdir}/tomcat-coyote.jar
%{libdir}/tomcat-i18n-es-%{version}.jar
%{libdir}/tomcat-i18n-es.jar
%{libdir}/tomcat-i18n-fr-%{version}.jar
%{libdir}/tomcat-i18n-fr.jar
%{libdir}/tomcat-i18n-ja-%{version}.jar
%{libdir}/tomcat-i18n-ja.jar
%{libdir}/tomcat7-jsp-%{jspspec}-api-%{version}.jar
%{libdir}/tomcat7-servlet-%{servletspec}-api-%{version}.jar
%{libdir}/commons-logging-api.jar
%{libdir}/commons-logging-adapters.jar

%files servlet-%{servletspec}-api
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-servlet-%{servletspec}-api-%{version}.jar
%{_javadir}*/%{name}-servlet-%{servletspec}-api.jar
%ghost %{_javadir}*/servlet.jar

%files webapps
%defattr(0664,tomcat,root,0775)
%attr(0775,tomcat,root) %{appdir}/ROOT
%attr(0775,tomcat,root) %{appdir}/examples
#%attr(0775,tomcat,root) %{appdir}/sample

%if %with zips
%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}*/jbossas-fordev
%{_javadir}*/jbossas-fordev/tomcat7-%{version}.zip
%{_javadir}*/jbossas-fordev/tomcat7-%{version}-examples.zip

%files src-zip
%defattr(0644,root,root,0755)
%dir %{_javadir}*/jbossas-fordev
%{_javadir}*/jbossas-fordev/tomcat7-%{version}-src.zip
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Oct 16 2012 Daivd Knox <dknox@redhat.com> 0:7.0.30-2_patch_01
- Resolves: JBPAPP-10179
- Rename el_api.jar to el-api.jar to match pom and zip contents
- Remove tomcat-dbcp from zip distro.
- Remove references to juli-adapters because it was redundant. Resource
- is really commons-logging-api.
- Add log4j.properties to zip extras.

* Mon Sep 17 2012 David Knox <dknox@redhat.com> 0:7.0.30-1_patch_01
- Updated sources to tc 7.0.30. 
- Resolves: JBPAPP-9557 Remove catalina-ha from distros

* Thu Aug 9 2012 David Knox <dknox@redhat.com> 0:7.0.29-2_patch_01
- Add SELinux. Correct init script SU macro. 

* Mon Jul 30 2012 David Knox <dknox@redhat.com> 0:7.0.29-1_patch_01
- cloned from jb-eap-6-rhel-6

* Tue Jun 26 2012 David Knox <dknox@redhat.com> 0:7.0.28-4_patch_01
- Commons-daemon-eap6 required renaming to commons-daemon
- Fixed useradd to use nologin instead of sh
- Signing zips is turned off. Tomcat6 and tomcat7 now have the same
- jars. Signing was not happening as expected, that is, jars were signed by
- the tomcat6 build but not the tomcat7 build. There was no difference in the 
- way signing was configured or called.

* Fri Jun 22 2012 David Knox <dknox@redhat.com> 0:7.0.28-3_patch_01
- Fixed broken symlink to commons-logging-api. Both BR and R exist.
- Link will fail but copy will work. It is now copied like the others

* Thu Jun 21 2012 David Knox <dknox@redhat.com> 0:7.0.28-2_patch_01
- Library fixes to make zips and rpms symmetrical. Copy EWS2 libs
- into zips.

* Wed Jun 20 2012 David Knox <dknox@redhat.com> 0:7.0.28-1_patch_01
- Update to tc 7.0.28. Remove commons-logging-tomcat-juli. It is not
- an EWS2 package. Repair broken symlinks to dbcp,pool, & collections.
- Had to copy instead of link.

* Mon Jun 11 2012 David Knox <dknox@redhat.com> 0:7.0.27-8_patch_01
- Replace jakarta-commons-[dbpc,pool,collections,daemon] with 
- apache-commons-*-eap6. Update commons-logging to eap6 libs. 

* Tue Jun 5 2012 David Knox <dknox@redhat.com> 0:7.0.27-7_patch_01
- Resolved: Broken symlinks jasper-jdt (ecj3) and
- commons-logging-tomcat-juli (removed from the build as redundant.
- tomcat-juli.jar is a conglomeration of commons-logging-tomcat-juli
- and tomcat-juli.jar )
- Removed R for jakarta-taglibs-standard which is not necessary

* Thu May 17 2012 David Knox <dknox@redhat.com> 0:7.0.27-6_patch_01
- Remove jscv from build

* Sat Apr 28 2012 David Knox <dknox@redhat.com> 0:7.0.27-5_patch_01
- Remove RSA and JBoss policy. No longer needed since jars are not signed

* Fri Apr 27 2012 Permaine Cheung <pcheung@redhat.com. 0:7.0.27-4_patch_01
- Unsign jars, except for the ones in repolib for MEAD upload

* Fri Apr 27 2012 David Knox <dknox@redhat.com. 0:7.0.27-3_patch_01
- WIP - need to turn jar signing off

* Mon Apr 23 2012 David Knox <dknox@redhat.com> 0:7.0.27-2_patch_01
- Fixed pom artifactIDs

* Tue Apr 17 2012 David Knox <dknox@redhat.com> 0:7.0.27-1_patch_01
- Update to 7.0.27

* Thu Apr 12 2012 David Knox <dknox@redhat.com> 0:7.0.25-2_patch_01
- After WIP commit and push of -1_patch_01. Build works.

* Tue Feb 14 2012 David Knox <dknox@redhat.com> 0:7.0.25-1_patch_01
- Import from jb-eap-6-rhel-6

